package no.statnett.ecp.edx;

import java.util.HashSet;
import java.util.Set;

public class Measurement {
  private long yyyyMMddHHmm;
  private boolean snd;
  private Set<String> ecpIds = new HashSet<>();
  private Set<String> edxIds = new HashSet<>();


  public Measurement(long yyyyMMddHHmm, boolean snd) {
    this.yyyyMMddHHmm = yyyyMMddHHmm;
    this.snd = snd;
  }

  public long getTms() {
    return yyyyMMddHHmm;
  }

  public void addEcpId(String ecpId) {
    ecpIds.add(ecpId);
  }

  public void addEdxId(String edxId) {
    edxIds.add(edxId);
  }

  public int diff() {
    // If you send messages, you can allow that ECP size is bigger than EDX size
    // If you receive messages, you can allow that EDX size is bigger than ECP size
    if (snd) {
      return ecpIds.size() - edxIds.size(); // Should never be less than 0
    } else {
      return edxIds.size() - ecpIds.size(); // Should never be less than 0
    }
  }

  public void add(Measurement fm) {
    ecpIds.addAll(fm.ecpIds);
    edxIds.addAll(fm.edxIds);
  }

  public int getEcpTraffic() {
    return ecpIds.size();
  }

  public int getEdxTraffic() {
    return edxIds.size();
  }
}
